#include "system.h"
#include <fract.h>
#include <complex.h>
#include <filter.h>
#include <sysreg.h>

// temp storage
section("L1_data_a") complex_fract16 t[Number_of_Samples/2];  

// output
section("L1_data_b") complex_fract16 out[Number_of_Samples/2];

// twiddle factors
#define TWIDDLE_SIZE Number_of_Samples/2

section("L1_data_a") complex_fract16 w[Number_of_Samples/2]; 


void init_twiddle()
{
	twidfftrad2_fr16(w, Number_of_Samples/2);
}

void process()
{
	volatile int i;

// Comment the following two lines if the demonstrational FFT processing is to be performed
//	for (i=(half * Number_of_ADC_channels * Number_of_Samples); i<((half+1) * Number_of_ADC_channels * Number_of_Samples); i++)
//		sPPI_TxBuffer[i] = (sPPI_RxBuffer[i] & 0xFFF0);

// Uncomment to perform FFT and IFFT on ADC data 
// (NOTE: you must set the DAC data format to 2's complement via SPI if adding this processing.
//	See Init_AD9866() in main.c )


		cfft_fr16((const complex_fract16 *) (&sPPI_RxBuffer[0] + half*Number_of_Samples), t, out, w, 2*TWIDDLE_SIZE/Number_of_Samples, Number_of_Samples/2, 1, 2);
		ifft_fr16( out, t, out, w, 2*TWIDDLE_SIZE/Number_of_Samples, Number_of_Samples/2, 1, 2);
		for(i=0;i<(Number_of_Samples/2);i++)
		{
			sPPI_TxBuffer[2*(i+half*(Number_of_Samples/2))] = (short) ((out[i].re << 4) * 32);
			sPPI_TxBuffer[2*(i+half*(Number_of_Samples/2))+1] = (short) ((out[i].im << 4) * 32);
		}


} 

